## START: Set by rpmautospec
## (rpmautospec version 0.8.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by rust2rpm 27
%bcond check 1

%global crate oxipng

Name:           rust-oxipng
Version:        9.1.4
Release:        %autorelease
Summary:        Lossless PNG compression optimizer

License:        MIT
URL:            https://crates.io/crates/oxipng
Source:         %{crates_source}
# * We need the GitHub archive, in addition to the .crate from crates.io,
#   because the crate does not contain the xtask/ directory required for
#   generating a man page. As noted in
#   https://github.com/shssoichiro/oxipng/issues/654, there are technical
#   obstacles to including this in the crate. This source also includes the
#   tests/ directory, which allows us to run tests.
Source10:       https://github.com/shssoichiro/oxipng/archive/v%{version}/oxipng-%{version}.tar.gz
# Automatically generated patch to strip dependencies and normalize metadata
Patch:          oxipng-fix-metadata-auto.diff
# Manually created patch for downstream crate metadata changes
Patch:          oxipng-fix-metadata.diff

BuildRequires:  cargo-rpm-macros >= 24

%global _description %{expand:
A lossless PNG compression optimizer.}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}
# Apache-2.0
# Apache-2.0 OR MIT
# Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT
# MIT
# MIT OR Apache-2.0
# Zlib OR Apache-2.0 OR MIT
License:        %{shrink:
                Apache-2.0 AND
                (Apache-2.0 OR MIT) AND
                (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND
                MIT AND
                (Zlib OR Apache-2.0 OR MIT)
                }
# LICENSE.dependencies contains a full license breakdown

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE
%license LICENSE.dependencies
%doc CHANGELOG.md
%doc MANUAL.txt
%doc README.md
%{_bindir}/oxipng
%{_mandir}/man1/oxipng.1*

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%files          devel
%license %{crate_instdir}/LICENSE
%doc %{crate_instdir}/CHANGELOG.md
%doc %{crate_instdir}/MANUAL.txt
%doc %{crate_instdir}/README.md
%{crate_instdir}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages which
use the "default" feature of the "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+binary-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+binary-devel %{_description}

This package contains library source intended for building other packages which
use the "binary" feature of the "%{crate}" crate.

%files       -n %{name}+binary-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+filetime-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+filetime-devel %{_description}

This package contains library source intended for building other packages which
use the "filetime" feature of the "%{crate}" crate.

%files       -n %{name}+filetime-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+freestanding-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+freestanding-devel %{_description}

This package contains library source intended for building other packages which
use the "freestanding" feature of the "%{crate}" crate.

%files       -n %{name}+freestanding-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+parallel-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+parallel-devel %{_description}

This package contains library source intended for building other packages which
use the "parallel" feature of the "%{crate}" crate.

%files       -n %{name}+parallel-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+sanity-checks-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+sanity-checks-devel %{_description}

This package contains library source intended for building other packages which
use the "sanity-checks" feature of the "%{crate}" crate.

%files       -n %{name}+sanity-checks-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+system-libdeflate-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+system-libdeflate-devel %{_description}

This package contains library source intended for building other packages which
use the "system-libdeflate" feature of the "%{crate}" crate.

%files       -n %{name}+system-libdeflate-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+zopfli-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+zopfli-devel %{_description}

This package contains library source intended for building other packages which
use the "zopfli" feature of the "%{crate}" crate.

%files       -n %{name}+zopfli-devel
%ghost %{crate_instdir}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version} -p1
# Copy in the xtask/ directory from the GitHub archive, required for generating
# the man page. Remove upstream’s lock file, which we cannot respect. Note
# that the mangen xtask has its own dependencies, so we must run
# %%cargo_generate_buildrequires in the xtask directory if we are to invoke it
# in the build.
tar -xzvf '%{SOURCE10}' --strip-components=1 oxipng-%{version}/xtask
rm xtask/Cargo.lock
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires
pushd xtask >/dev/null
%cargo_generate_buildrequires
popd >/dev/null

%build
%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies
# Generate the man page
%{__cargo} run --manifest-path xtask/Cargo.toml -- mangen

%install
%cargo_install
mansrc='target/xtask/mangen/manpages/oxipng.1'
mandest='%{buildroot}%{_mandir}/man1'
install -t "${mandest}" -D -p -m 0644 "${mansrc}"

%if %{with check}
%check
# Copy in the tests/ directory, which gives us some actual tests. We do this
# here rather than in %%prep in order to prove that nothing from tests/
# contributes to the binary RPMs.
tar -xzvf '%{SOURCE10}' --strip-components=1 oxipng-%{version}/tests
%cargo_test
%endif

%changelog
## START: Generated by rpmautospec
* Fri Apr 18 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 9.1.4-2
- Rebuilt with rust-zopfli 0.8.2, with performance improvements

* Sat Feb 15 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 9.1.4-1
- Update to 9.1.4 (close RHBZ#2345843)

* Sun Jan 19 2025 Fedora Release Engineering <releng@fedoraproject.org> - 9.1.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Sat Nov 30 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 9.1.3-1
- Update to 9.1.3 (close RHBZ#2329572)

* Mon Jul 22 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 9.1.2-3
- Re-enable features that require rust-image 0.25

* Sat Jul 20 2024 Fedora Release Engineering <releng@fedoraproject.org> - 9.1.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Mon Jul 15 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 9.1.2-1
- Update to 9.1.2 (close RHBZ#2297884)

* Thu May 23 2024 Fabio Valentini <decathorpe@gmail.com> - 9.1.1-3
- Rebuild with Rust 1.78 to fix incomplete debuginfo and backtraces

* Fri Apr 26 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 9.1.1-2
- Hide the image and sanity-checks crate features

* Wed Apr 24 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 9.1.1-1
- Update to 9.1.1 (close RHBZ#2276572)
- Replace downstream man page with upstream generated man page

* Sat Mar 16 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 9.0.0-4
- Add a man page

* Fri Mar 15 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 9.0.0-3
- Use rust2rpm 26 features to simplify packaging

* Sat Feb 17 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 9.0.0-1
- Unretire and update to 9.0.0 (close RHBZ#2259760)

* Mon May 31 2021 Rémi Lauzier <remilauzier@protonmail.com> - 4.0.3-1
- Initial package

## END: Generated by rpmautospec
